-- Memory Cleaner by MikuAuahDark

-- User Configuration
CleanTimes=5	-- Do memory clean every x times(default 5)
TimeToClean=300	-- Do memory clean only every x seconds(default 5 minutes, 300 seconds)
ShowMsg=true	-- Show message when start cleaning
NormHook=true	-- Always use normal hooking method even if Improved addhook LUA is exist(true by default because it little faster)
-- End of user configuration. It's your risk to edit code below

-- Check for hooking method
if NormHook then
	(((ah2 or nil) and ah2.original_addhook) or addhook)("second","MemoryCleaner")
else
	addhook("second","MemoryCleaner")
end
-- Declare function
function MemoryCleaner()
	-- Check if is a 5 minutes already passed
	if os.time()%TimeToClean==0 then
		-- Check if a ShowMsg variable is set to true
		if ShowMsg==true then
			-- Showing message
			print("Performing memory cleaner, clean every "..CleanTimes.." time(s)")
			-- Do cleaning loop
			for i=1,CleanTimes do
				-- Memory used in KB before cleaning
				local before=math.floor(collectgarbage("count"))
				-- Clean Memory/Collect Garbage
				collectgarbage("collect")
				-- Show message
				print("Clean "..i.." complete, "..(before-math.floor(collectgarbage("count"))).."Kbytes cleaned!")
			end
		-- Don't show message
		else
			-- Do cleaning loop
			for i=1,CleanTimes do
				-- Clean Memory/Collect Garbage
				collectgarbage("collect")
			end
		end
	end
end